# Arcadeflow - Attract Mode theme by zpaolo11x - v 3.9 #

Arcadeflow is an horizontal scrolling, grid based theme for MAME, it doesn't support multiple systems and is based on snapshots and game titles, not on flyers or cartridge boxes. If you have video snaps they will appear over the selected thumbnail without sound, and you can open a larger video preview with sound.

The layout adapts to different aspect ratios (5:4, 4:3, 16:9 and 16:10) automatically and reasonably well (external snaps get partially cut but not completely obscured) and a different layout is enabled for vertical aspect ratio.

Arcadeflow is heavily configurable, please take some time to go through the option and you'll see you can tailor it to most of your needs.

## What's new in v 3.9 #

- Fixed some bugs in the signal response code and sound management
- Added a "fade from black" effect when launching the layout
- Revised attract mode:
  - Attract mode is now on by default but not at startup, just after the delay
  - Streamlined the code, improved performance when it's enabled but not running
  - Added black crossfade when changing games
  - New options: chose wether attract mode satrts with the layout, only after delay time, or is disabled
  - Game rendering is done with a fixed number of scanlines (180) for every game
  - For lower resolution screens the number of pixels per scanline is optimized to avoid moiree
  - You can now add a sound file to play during attract mode
  - Added an option in the general menu to manually start attract mode without waiting

## Custom controls #

When you hit the "select" or "custom" control button (see layout options) an overlay context menu appears, here you can do different things to activate the following functions:

- "SELECT" launches the current game
- "UP" enters the "More of the same..." search function, filtering games with the same year, manufacturer, main category or sub-category of the current game
- "DOWN" enters the "History" page where you can see and scroll the game history and see a larger game preview
- "LEFT" to enter the Tags menu
- "RIGHT" to add/remove favorites
- "ESC" goes back to the thumbnail list

## General layout menu #

You can access a general menu by going "UP" from the first row of thumbnails. This menu features:

- "Filters" menu
- "Search" function (see options)
- "Layout options" from AM 2.4+
- "Attract Mode" to engage attract mode without waiting the timeout

## Tags #

You can add a "Completed" tag to games, that will add a "Completed" stamp on the thumbnails

## Sorting and scrolling #

When your list is sorted by name a large preview letter will appear while scrolling through the list. 
If your list is sorted by year the year will appear instead of the letter.
You can go "DOWN" from the altest row to enter a "large jumps" scrolling mode.

## Layout options #

GENERAL

- "Context Menu Button" : Setup the button to use to recall game info and actions context menu (can be "select")
- "Rows in horizontal" : Number of rows to use in 'horizontal' mode
- "Rows in vertical" : Number of rows to use in 'vertical' mode
- "Smooth shadow" : Enable smooth shadow under game title and data in the GUI
- "Screen rotation" : Select a persistent screen rotation option
- "Frosted glass" : Add a frosted glass effect for menu backgrounds
- "Resolution W x H" : Define a custom resolution for your layout independent of screen resolution

THUMBNAILS

- "Aspect ratio" : Chose wether you want cropped, square snaps or horizontal and vertical snaps
- "Glow effect" : Add a glowing halo around the selected game thumbnail
- "Video thumbs" : Enable video overlay on snapshot thumbnails
- "Thumb gradient" : Fades the artwork behind the game logo to its average color
- "New Game Indicator" : Games not played are marked with a glyph

BACKGROUND

- "Overlay Color" : Setup theme luminosity overlay
- "Custom BG Image" : Insert custom background art path
- "Background snap" : Add a faded game snapshot to the background
- "Animate BG snap" : Animate video on background

LOGO

- "Enable splash logo" : Enable or disable the AF start logo
- "Custom splash logo" : Chose a custom picture as splash logo

ATTRACT MODE

- "Enable attract mode" : Enable attract mode at layout startup, or after delay, or disable it
- "Custom attract music" : Insert the path to an mp3 you'd like to hear during attract mode
- "Enable game sound" : Enable game sounds during attract mode
- "Attract mode timer [s]" : Inactivity timer before attract mode is enabled
- "Game change time [s]" : Time interval between each game change
- "Attract message" : Text to show during attract mode

SEARCH

- "Search entry method" : Use keyboard or on-screen keys to enter search string
- "Immediate search" : Live update results while searching

HISTORY
- "Scanline effect" : Select scanline effect: default scanlines, half res scanlines, aperture mask or none
- "Text panel style" : Chose between a white history background or no background
- "Game panel style" : Select the look of the history game panel, dark or standard
- "History.dat" : History.dat location
- "Index Clones" : Set whether entries for clones should be included in the index.
- "Generate Index" : Generate the history.dat index now (this can take some time)

AUDIO

- "Theme sound" : Enables or disables the "click" and "woosh" theme sounds
- "Audio in videos (thumbs)" : Select wether you want to play audio in videos on thumbs
- "Audio in videos (history)" : Select wether you want to play audio in videos on history detail page

DEBUG

- "FPS Counter": Enable framerate counter for debug purposes

## Previous versions history #

*v 3.8*

- Added an "attract mode" that shows random game videos when AF is not active (see options)
- In options if you use "vignette.pmg" as custom background you get a corner vignette effect
- Added a grey shadow under the game title in history page
- Added the option to have a darker background for game preview in history page
- First and last lines of text in history page are now vanishing in the background color
- Text in history page slides up into place
- Changed the routine used for fade in - fade out, code is cleaner and effect is smoother
- Added a "DEBUG" option to enable a FPS counter (for debug purposes only)

*v 3.7*

- Customized CRT shader with vigneting effects.
- Added an option for history page game video: you can have "Aperture" instead of scanlines, half res scanlines or plain video.
- Changed the look of the history text with a white background, you can select it in the options.

*v 3.6*

- Arcadeflow 3.6 requires Attract Mode 2.5.
- Fixed some issues with AM 2.5 when adding or deleting favorites and tags.
- Changed the CRT filter in history page from cgwg shader to lotte shader, now scanlines are vertical for vertical games and aligned to the game actual pixels.
- Added options for history page that halves or removes scanlines so the moiree effect is less prominent.

*v 3.5*

- In layout options you can now choose if you want to use "select" or a "custom" control button to open the context menu.
- Revised the thumbnail glow bitmap and shader (again) so it's subtler and smoother.

*v 3.4*

- Custom control button not needed anymore, now when you hit "select" on a game you'll see the context menu, if you hit "select" again the game will play, otherwise you can use arrows as before for different functions
- Revised the context menu graphics
- Changed the way "color gradient" is calculated: instead of sampling some points on the image it uses an actual smoothed version of the image
- Changed the way "glow color" is calculated, takes its color from actual thumbnail (static or video) isntead of the average as before
- Added glowing effect in history page around the game display video

*v 3.3*

- Bug fixes for 1-row mode and for response to signals like next_game, next_page etc

*v 3.2*

- Revised the smooth shadow under texts, now it's resolution-independent and more optimized
- Added an option to have 1-row layouts for both horizontal and vertical
- Enlarged some elements of the UI for lower resolution screens

*v 3.1*

- Added indicators of number of players, game controls and game buttons
- Fixed some bugs in the category picture function
- Fixed bugs in the pop up letter routine

*v 3.0*

- Changed the way blurred fading backgrounds are layered
- Tweaked some graphics aspects
- Pop up letter now responds to the sort order of the game list
- Cleaned up some code
- Added an option to mute the theme "click" and "woosh" sounds
- Improved transparent PNGs for shadows and glows

*v 2.9*

- Redesigned the game data ribbon on top of the thumbnail grid
- Added category icons for game category
- Added manufacturer icons for game manufacturer
- Added a smooth drop shadow under game title, data and icons
- Streamlined the AF logo so it's just white 
- The technique used for background crossfade is used for game data crossfade too
- Frosted glass effect applied to the screen behind the logo

*v 2.8*

- Implemented a new, smoother system for background image crossfade
- Added a "look for the same..." + "Decade" search menu entry

*v 2.7*

- Fixed some bugs in screen rotation
- Added the possibility to define a layout resolution independent from screen resolution

*v 2.6*

- New "frosted glass" effect when you enter overlay menus
- Updated Readme.md with current options

*v 2.5*

- Added a new option to toggle screen rotation permanently

*v 2.4*

- Snapshots aspect ratio is now adapted to 4:3 or 3:4 automatically
- Some improvements to shaders, cleaned up the code
- Revamped the History page adding a CRT-like shader to the game preview
- Tweaked the appearance of themes (dark is now darker) and fixed some bugs in snapshots scaling

*v 2.3*

- Improved the overall speed by optimizing shaders and textures
- Added a new effect on the background where you can get a pixellated version of the snap or video
- Added a new glow effect around selected thumbs with the average thumb color
- Added the possibility to hear audio of the videos in the thumb and/or in the history page
- Revamped the options to make it more clear

*v 2.2*

- The thumbnail art fades to the average thumbnail color in the area behind the title logo, to improve readability
- Added an option "Smooth Gradient Snap" to enable/disable the fade effect
- In "Square" thumbs mode changed the position and aspect ratio of the logo so it's more on the top of the thumb

*v 2.1*

- Added some tweaks to make scrolling more fluid and correct slowdowns
- Fixed a bug in the background scaling blurred snap routine
- Changed the blur shader, now there are three layouts to chose from: layout, layout_noshader, layout_oldshader (with a lighter shader that is faster on some machines)

*v 2.0*

- New feature: you can now change the splash logo
- New feature: background artwork can be a semi-transparent PNG and will show the blurred background behind it
- Under the hood changes: version 2.0 is a huge rewrite of AF, no need to generate blurred backgrounds or blurred logo shadows with xnview, the theme can generate on the fly shadows and backgrounds from your snapshots and wheel artwork. The theme may be a bit slower on your system depending on the size of artworks which is generally larger than xnview generated blurred pictures.
- If you have issues with the new way "blur" is generated you can use the layout_noshader.nut file instead, just chose it from the layout options menu (AM 2.4) or rename it to layout.nut (AM 2.3). This layout file has all the features of the new one, but in a standard framework using xnview generated artwork

*v 1.9*

- AM 2.4 was released while coding AF 1.9, adapted the code so it works both in 2.3 and 2.4:
  - Fixed the zorder management 
  - Implemented a new way to crop thumbnails for "square" thumbs layout 
  - 2.4 users can access the "Layout Options" menu directly from the "General" menu accessible going "Up" from the game grid
  - Rewritten the scrolling title routine with proper timing
- Custom background picture is not stretched but scaled/cropped to fit the theme aspect ratio
- Thoroughly rewritten the transition response routine, it's cleaner and works much better now.
- Thanks to the above rewrite you can now use "left" and "right" on the History screen to go to the previous/next game, the layout should now respond correctly even to "jump to letter" calls and page jumps.
- "Square" thumbnails layout now responds to the "Blurred Logo Shadow" option, if you enable it you'll get game name overlay with drop shadow, otherwise plain game name with gradient background.
- When a game has a multi-language title separated by "/" (e.g. Fatal Fury / Garou Densetsu) the theme will crossfade the titles so that title scrolling is needed less often.

*v 1.8*

- Introduced a new layout style where game snaps are not horizontal or vertical depending on game orientation, but cropped square. You can chose it in the options menu.

*v 1.7*

- Overhauled the menu and functions system, now it works like this:
  - When going "UP" from the tiles list you get to a "main menu" where you can select Filters Menu or Global Search
  - When on a game using the configurable control button you get a "context menu" overlay with 4 game-specific functions you chose by using your joystick/keys:
    - "UP" enters the "More of the same..." search menu
    - "DOWN" enters the "History" page where you can see and scroll the game history and see a larger game preview
    - "LEFT" to enter the Tags menu
    - "RIGHT" to add/remove favorites
- Implemented a version of the History.dat plugin so you can see history without the need to enable the plugin (see options)
- Rolled back the way horizontal and vertical games are detected, the "new" one had some issues in many circumstances
- Tweaked and updated search with on-screen keys
- Added a workaround when invoking filters through the filters menu button to fix some tiles update

- New theme options included: 
  -	"History.dat" is the location of the History.dat file (no need to enable or configure the )
  - "Index Clones" works like the same option in the History.dat plugin.
  - "Generate Index" a one-time function to generate the history index

*v 1.6*

- Changed the way horizontal and vertical games are detected, this time it should work for all users and all games lists
- Changed the way the "vertical" mode is scaled and layed out, clearer and with larger thumbs 
- Search features that require tex input now also work with on-screen keys (embedded the KeyboardSearch plugin)
- New theme options included: 
  -	"Search string entry method" to chose if you want to use a keyboard or a joystick and on screen keys to enter text
	- "Immediate search" will live update results while you enter search text using the on screen keys
	- "Enable AF splash logo" enables/disables the fading splash Arcadeflow logo
  - "Vertical rows" allows to use 2 or 3 rows of icons in vertical mode

*v 1.5*

- New shadows graphics, smoother and more modern-looking 
- New and improved search features:
  - use "Custom 2" to filter games with the same year, manufacturer, main category and sub-category of the current game (e.g. shooters, or horizontal shooters)
  - use "Custom 3" to open a menu and search in games titles, years, manufacturers or categories
- When toggling screen rotation using AttractMode hotkeys the screen updates to the vertical layout if needed.

*v 1.4*

- Changed (again) splash screen graphics at startup (new AF logo) 
- Introducing theme options:
  - You can chose the theme's... theme :D There are 4 choices: "Default" (greyed blurred background), "Dark", "Light" (dark and light blurred background), "Pop" (blurred background colors unaltered)
  - You can chose whether you want "hard edged" game title shadows or "smooth" game title shadows, the latter requires new artwork (see below)
  - You can chose whether you want to place a marker on unplayed games
  - You can place a background image, this will be affected by the theme choice and will override the blurred background
- Minor tweaks and speedups, now each sections retaines the latest selected game

*v 1.3*

- Key repeat rate limited to allow more fluid scrolling of tiles 
- Added selection sound
- Changed splash screen graphics at startup

*v 1.2*

- Scrolling game title when the title size is too big to fit the screen 
- If you go "up" from the first row you enter the "Filters" menu
- If you go "down" from the second row the scrollbar highlights and you can jump screens faster
- Improved scrolling speed on some systems
- Added a splash screen at startup

*v 1.1*

- The games list is not repeating
- Tweaked scrolling at the beginning of the list so the first game column is not centered
- Changed the timing so that when the video snapshot is loaded the scrolling doesn't stutter
- Number of columns automatically calculated
- Better support for vertical displays

*v 1.0*

- First release
